#include "mainwindow.h"
#include "ui_mainwindow.h"
#include <QListWidgetItem>
//
#include "rootclass.h"
#include "childclass.h"

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::on_pushButtonCreateRoot_clicked()
{
    RootClass *newRoot = new RootClass;
    QListWidgetItem *item = new QListWidgetItem;
    item->setSizeHint(newRoot->size());
    ui->listWidgetRoot->addItem(item);
    ui->listWidgetRoot->setItemWidget(item, newRoot);
}

void MainWindow::on_pushButtonCreateChild_clicked()
{
    if(ui->listWidgetRoot->currentRow() > -1)
    {
        QListWidgetItem *item = ui->listWidgetRoot->item(ui->listWidgetRoot->currentRow());
        RootClass *selectedRoot = dynamic_cast<RootClass*>(ui->listWidgetRoot->itemWidget(item));
        ChildClass *newChildClass = new ChildClass;
        selectedRoot->ChildClassList.append(newChildClass);
        //
        ui->listWidgetChild->clear();
        //
        if(selectedRoot->ChildClassList.size() > 0)
            for(int i=0; i <= selectedRoot->ChildClassList.size(); ++i)
            {
                ChildClass *ChildRootFromList = dynamic_cast<ChildClass*>(selectedRoot->ChildClassList.at(i));
                QListWidgetItem *item = new QListWidgetItem;
                item->setSizeHint(ChildRootFromList->size());
                ui->listWidgetChild->addItem(item);
                ui->listWidgetChild->setItemWidget(item, ChildRootFromList);
            }
    }
}

void MainWindow::on_listWidgetRoot_currentRowChanged(int currentRow)
{
    if(ui->listWidgetRoot->currentRow() > -1)
    {
        QListWidgetItem *item = ui->listWidgetRoot->item(currentRow);
        RootClass *selectedRoot = dynamic_cast<RootClass*>(ui->listWidgetRoot->itemWidget(item));
        //
        ui->listWidgetChild->clear();
        //
        if(selectedRoot->ChildClassList.size() > 0)
        for(int i=0; i <= selectedRoot->ChildClassList.size(); i++)
        {
            ChildClass *ChildRootFromList = dynamic_cast<ChildClass*>(selectedRoot->ChildClassList.at(i));
            QListWidgetItem *item = new QListWidgetItem;
            item->setSizeHint(ChildRootFromList->size());
            ui->listWidgetChild->addItem(item);
            ui->listWidgetChild->setItemWidget(item, ChildRootFromList);
        }
    }
}
